<template>
    <div>

        <br>

        <div>
            <h5>Neue TrainerIn hinzufügen</h5>
            <b-button id="show-btn" variant="success" @click="showModal">
                <b-icon icon="plus-square" aria-hidden="true"></b-icon>
            </b-button>

            <br>
            <br>

            <h5>Nettogehalt ausrechnen</h5>

            <b-button  id="show-btn" variant="warning" @click="myFunction()">
                <b-icon icon="calculator-fill" aria-hidden="true"></b-icon>
            </b-button>

            <b-modal ref="my-modal" @hidden="resetModal" hide-footer>
                <div class="d-block text-center">
                    <form method="post">
                        <b-container fluid>
                            <b-row class="my-1">
                                <b-col sm="1">
                                </b-col>
                                <b-col sm="10">
                                    <b-form-input id="input-large" size="lg" placeholder="Namen eingeben"
                                        v-model="trainerInnen.name"></b-form-input>
                                </b-col>
                            </b-row>
                            <b-row class="my-1">
                                <b-col sm="1">
                                </b-col>
                                <b-col sm="10">
                                    <b-form-input id="input-large" size="lg" placeholder="E-Mail eingeben"
                                        v-model="trainerInnen.eMail"></b-form-input>
                                </b-col>
                            </b-row>
                            <b-row class="my-1">
                                <b-col sm="1">
                                </b-col>
                                <b-col sm="10">
                                    <b-form-input id="input-large" size="lg" placeholder="Adresse eingeben"
                                        v-model="trainerInnen.adresse"></b-form-input>
                                </b-col>
                            </b-row>
                            <b-row class="my-1">
                                <b-col sm="1">
                                </b-col>
                                <b-col sm="10">
                                    <b-form-input id="input-large" size="lg" placeholder="Telefonnummer eingeben"
                                        v-model="trainerInnen.telnum"></b-form-input>
                                </b-col>
                            </b-row>

                            <b-row class="my-1">
                                <b-col sm="1">
                                </b-col>
                                <b-col sm="10">
                                    <b-form-input id="input-large" size="lg" placeholder="Brutto-Gehalt eingeben"
                                        v-model.number="trainerInnen.bruttoGehalt"></b-form-input>
                                </b-col>
                            </b-row>

                            <b-row class="my-1">
                                <b-col sm="1">
                                </b-col>
                                <b-col sm="10">
                                    <label for="tags-basic">Unterrichtseinheit auswählen</label>
                                    <select class="form-select form-select-lg mb-3" aria-label=".form-select-lg example"
                                        v-model="trainerInnen.fachId">
                                        <option v-for="fach in faecher" v-bind:key="fach.id"
                                            :value="fach.fach_id"> {{ fach.fachEnums }}
                                        </option>
                                    </select>
                                </b-col>
                            </b-row>                        

                            <b-row class="my-1">
                                <b-col sm="1">
                                </b-col>
                                <b-col sm="10">
                                    <label for="tags-basic">Anstellungsart wählen</label>
                                    <select class="form-select form-select-lg mb-3" aria-label=".form-select-lg example"
                                        v-model="trainerInnen.anstellungEnums">
                                        <option value="VOLLZEIT">Vollzeit</option>
                                        <option value="TEILZEIT">Teilzeit</option>
                                        <option value="SELBSTSTAENDIG">Selbstständig</option>
                                    </select>
                                </b-col>
                            </b-row>
                        </b-container>
                        <div>
                            <b-button block variant="outline-success" @click="postTrainerIn()">
                                Speichern</b-button>
                        </div>
                    </form>
                </div>
            </b-modal>
        </div>

        <div>
            <b-modal ref="my-modal1" hide-footer>
                <div class="d-block text-center">
                    <form method="post">
                        <b-container fluid>
                            <b-row class="my-1">
                                <b-col sm="1">
                                </b-col>
                                <b-col sm="10">
                                    <b-form-input id="input-large" size="lg" v-model="editTrainerInnen.name">
                                    </b-form-input>
                                </b-col>
                            </b-row>
                            <b-row class="my-1">
                                <b-col sm="1">
                                </b-col>
                                <b-col sm="10">
                                    <b-form-input id="input-large" size="lg" v-model="editTrainerInnen.eMail">
                                    </b-form-input>
                                </b-col>
                            </b-row>
                            <b-row class="my-1">
                                <b-col sm="1">
                                </b-col>
                                <b-col sm="10">
                                    <b-form-input id="input-large" size="lg" v-model="editTrainerInnen.adresse">
                                    </b-form-input>
                                </b-col>
                            </b-row>
                            <b-row class="my-1">
                                <b-col sm="1">
                                </b-col>
                                <b-col sm="10">
                                    <b-form-input id="input-large" size="lg" v-model="editTrainerInnen.telnum">
                                    </b-form-input>
                                </b-col>
                            </b-row>
                            <b-row class="my-1">
                                <b-col sm="1">
                                </b-col>
                                <b-col sm="10">
                                    <b-form-input id="input-large" size="lg"
                                        v-model.number="editTrainerInnen.bruttoGehalt">
                                    </b-form-input>
                                </b-col>
                            </b-row>

                            <b-row class="my-1">
                                <b-col sm="1">
                                </b-col>
                                <b-col sm="10">
                                    <label for="tags-basic">Unterrichtseinheit auswählen</label>
                                    <select class="form-select form-select-lg mb-3" aria-label=".form-select-lg example"
                                        v-model="editTrainerInnen.fachId">
                                        <option v-for="fach in faecher" v-bind:key="fach.id"
                                            :value="fach.fach_id"> {{ fach.fachEnums }}
                                        </option>
                                    </select>
                                </b-col>
                            </b-row> 


                            <!-- <b-row class="my-1">
                                <b-col sm="1">
                                </b-col>
                                <b-col sm="10">
                                    <b-form-input id="input-large" size="lg" placeholder="Fach ID eingeben"
                                        v-model.number="editTrainerInnen.fachId">
                                    </b-form-input>
                                </b-col>
                            </b-row> -->

                            <b-row class="my-1">
                                <b-col sm="1">
                                </b-col>
                                <b-col sm="10">
                                    <select class="form-select form-select-lg mb-3" aria-label=".form-select-lg example"
                                        v-model="editTrainerInnen.anstellungEnums">
                                        <option value="VOLLZEIT">Vollzeit</option>
                                        <option value="TEILZEIT">Teilzeit</option>
                                        <option value="SELBSTSTAENDIG">Selbstständig</option>
                                    </select>
                                </b-col>
                            </b-row>
                        </b-container>
                        <b-button class="mt-3" variant="outline-success" @click="putTrainerIn()" block>Speichern
                        </b-button>
                    </form>
                </div>

            </b-modal>
        </div>

        <br>

        
        <table class="table">
            <tbody>
                <tr>
                    <!-- <th>ID</th> -->
                    <th>Name</th>
                    <th>E-Mail Adresse</th>
                    <th>Adresse</th>
                    <th>Telefonnummer</th>
                    <th>Anstellungsart</th>
                    <th>Brutto Gehalt</th>
                    <th></th>
                    <th></th>
                </tr>
                <tr v-for="trainer in trainerIn" v-bind:key="trainer.id">
                    <!-- <td>{{ trainer.id }}</td> -->
                    <td>{{ trainer.name }}</td>
                    <td>{{ trainer.eMail }}</td>
                    <td>{{ trainer.adresse }}</td>
                    <td>{{ trainer.telnum }}</td>
                    <td>{{ trainer.anstellungsart }}</td>
                    <td>{{ trainer.bruttoGehalt }}</td>
                    <td>
                        <b-button id="show-btn" @click="showModal1(trainer.id), editTrainerIn(trainer)"
                            variant="primary">
                            <b-icon icon="pencil" aria-hidden="true"></b-icon>
                        </b-button>
                    </td>
                    <td>
                        <b-button @click="deleteTrainerIn(trainer.id)" variant="danger">
                            <b-icon icon="trash-fill" aria-hidden="true"></b-icon>
                        </b-button>
                    </td>
                </tr>
            </tbody>
        </table>
    </div>
</template>

<script>


export default {
    name: "TrainerInnenListe",
    data() {
        return {
            modalShow: false,
            trainerInnen: {
                name: '',
                eMail: '',
                adresse: '',
                telnum: '',
                anstellungEnums: '',
                bruttoGehalt: '',
                fachId: ''
            },
            editTrainerInnen: {
                name: '',
                eMail: '',
                adresse: '',
                telnum: '',
                anstellungEnums: '',
                bruttoGehalt: '',
                fachId: '',
                id: ''
            }
        }
    },
    computed: {
        trainerIn() {
            return this.$store.state.trainerIn;
        },
        faecher() {
            return this.$store.state.faecher;
        }
    },
    methods:
    {

        myFunction() {
            window.open("https://bruttonetto.arbeiterkammer.at/", "_blank", "toolbar=yes,scrollbars=yes,resizable=yes,top=500,left=500,width=400,height=400")
        },

        deleteTrainerIn(id) {
            this.$store.dispatch('deleteTrainerIn', id)
        },

        postTrainerIn() {
            this.$store.dispatch('postTrainerIn', this.trainerInnen)

            this.hideModal()

        },

        putTrainerIn() {
            this.$store.dispatch('putTrainerIn', this.editTrainerInnen)
            this.hideModal1()
        },

        async editTrainerIn(trainer) {
            this.editTrainerInnen.name = trainer.name;
            this.editTrainerInnen.eMail = trainer.eMail;
            this.editTrainerInnen.adresse = trainer.adresse;
            this.editTrainerInnen.telnum = trainer.telnum;
            this.editTrainerInnen.anstellungEnums = trainer.anstellungEnums;
            this.editTrainerInnen.bruttoGehalt = trainer.bruttoGehalt;
            this.editTrainerInnen.fachId = trainer.fachId;
            this.editTrainerInnen.id = trainer.id;

        },
        resetModal() {
            this.trainerInnen.name = ''
            this.trainerInnen.eMail = ''
            this.trainerInnen.adresse = ''
            this.trainerInnen.telnum = ''
            this.trainerInnen.anstellungEnums = ''
            this.trainerInnen.bruttoGehalt = ''
            this.trainerInnen.fachId = ''
        },
        showModal() {
            this.$refs['my-modal'].show()
        },
        showModal1() {
            this.$refs['my-modal1'].show()
        },
        hideModal() {
            this.$refs['my-modal'].hide()
        },
        hideModal1() {
            this.$refs['my-modal1'].hide()
        }
    },
    mounted() {
        this.$store.dispatch('getAlleTrainnerInnen');
        this.$store.dispatch('getAlleFaecher');
    },
    

}



</script>